<?php

abstract class Controller
{

        protected $data = array();
        protected $view = "";
        protected $module = "";
        protected $header = array('title' => '', 'keywords' => '', 'description' => '');
        protected $do;
        protected $components = array();
        protected $dataManager;
        public $mainLayout = "layout";



        public function createTheComponent($name, $data){
            $component = new Component($name, $data);
            $this->components[$name] = $component;
        }

        public function renderComponent($name){
                $this->components[$name]->render();
        }

        public function __construct($dataManager){
            $this->dataManager = $dataManager;
        }

        abstract function action($parameters);

        public function setController($controller){
            $this->data['controller'] = $controller;
        }
        public function render()
        {
                if ($this->view)
                {
                    extract($this->data);
                    require_once('../app/modules/'.$this->module.'/view/'.$this->view.'.phtml');
                }
        }

        public function redirect($url)
        {
                header("Location: /$url");
                header("Connection: close");
                exit;
        }

        public function isAuthenticateAccess(){
                $uid = $_SESSION["uid"];
                $token = $_SESSION["token"];
                $login = $_SESSION["login"];
                $user = false;
                $last_activity = $_SESSION["LAST_ACTIVITY"];
                //$_SESSION["URL"] = "http://www.lightmanager.vavo.cz/$_SERVER[REQUEST_URI]";

                if (isset($last_activity) && (time() - $last_activity > 3600)) {
                        $this->redirect("account/odhlaseni");
                }

                $_SESSION["LAST_ACTIVITY"] = time();

                if(isset($token) && isset($uid)){
                        $user = $this->model->getUserByAuthCreditals($uid,$token);
                }

                return (bool)(count($user) && $login);
                //return (bool)$login;
        }

}