<?php
class UserController extends Controller{

    /**
     * @var UserModel
     */
    protected $model;
    protected $message = "";
    protected $GET = null;

    public function __construct($model){
        $this->model = $model;
        $session = new \Light\Session();
        $session->newDBSession();
        $this->GET = $_GET;

        if(!$this->isAuthenticateAccess()){
            $this->redirect("account/prihlaseni");
        }
    }

    function action($parameters)
    {
        if($parameters["pageAction"] == "upravit"){
            $this->actionEdit($parameters);
        }else{
            $user = $this->model->getUserByID($_SESSION["uid"]);

            $this->header['title'] = 'Profil';

            $this->data["display1"] = "none";
            $this->data["display2"] = "block";
            $this->fillViewVariables($user);
            $this->view = 'profile';
        }
    }

    public function actionEdit($parameters){

        $this->header['title'] = 'Upravit profil';
        $user = $this->model->getUserByID($_SESSION["uid"]);

        if(count($_POST)){
            $type = $_POST["address1-type"];
            $st = $_POST["address1-st"];
            $stnumber = $_POST["address1-stnumber"];
            $city = $_POST["address1-city"];
            $zip = $_POST["address1-zip"];

            $user->getAddresses()[0]->setType($type);
            $user->getAddresses()[0]->setStreet($st);
            $user->getAddresses()[0]->setStreetNumber($stnumber);
            $user->getAddresses()[0]->setCity($city);
            $user->getAddresses()[0]->setZip($zip);

            $this->dataManager->persist($user->getAddresses()[0]);
            $this->dataManager->reflect();
            $this->redirect("account/profil");
        }

        $this->data["display1"] = "block";
        $this->data["display2"] = "none";
        $this->fillViewVariables($user);
        $this->view = 'profile';
    }

    private function fillViewVariables($user){

        $this->data["name"] = $user->getUserName()." ".$user->getUserSurname();
        $this->data["address"] = $user->getAddresses()[0];

    }

    public function getMessage()
    {
        return $this->message;
    }

}
?>