<?php
namespace Light;

class MemCachedSessionHadler
{
    private static $lifetime = 0;

    public function __construct(){
        session_set_save_handler(
            array($this, "_open"),
            array($this, "_close"),
            array($this, "_read"),
            array($this, "_write"),
            array($this, "_destroy"),
            array($this, "_gc")
        );
    }

    public static function _open()
    {
        self::$lifetime = ini_get('session.gc_maxlifetime');

        return true;
    }

    public static function _read($id)
    {
        return memcached::get("sessions/{$id}");
    }

    public static function _write($id, $data)
    {
        return memcached::set("sessions/{$id}", $data, self::$lifetime);
    }

    public static function _destroy($id)
    {
        return memcached::delete("sessions/{$id}");
    }

    public static function _gc(){ return true; }
    public static function _close(){    return true; }
    public function __destruct()
    {
        session_write_close();
    }
}

?>
