<?php
namespace Light;

class Message{
    private $_messages = array();
    private $_types = array();
    private $_get = null;
    
    public function __construct() {
        if(isset($_SESSION["messages"])){
            $this->_messages = unserialize($_SESSION['messages']);
            $this->_types = unserialize($_SESSION['types']);
        }
    }
    
     public function save($message, $type){
            $this->_messages[] = $message;
            $this->_types[] = $type;
            $_SESSION['messages'] = serialize($this->_messages);
            $_SESSION['types'] = serialize($this->_types);
            return max(array_keys($this->_messages));
    }
    
    public function show($message = null, $type = null){
        if($this->_get == null && $message != null && $type != null){
            echo "<div class='alert alert-$type alert-dismissible' role='alert'>
                    <button type='button' class='close' data-dismiss='alert' aria-label='Close'><span aria-hidden='true'>&times;</span></button>
                    $message
                  </div>";
        }else{
            $message = "<div class='alert alert-{$this->types[$this->_get]} alert-dismissible' role='alert'>
                <button type='button' class='close' data-dismiss='alert' aria-label='Close'><span aria-hidden='true'>&times;</span></button>
                {$this->messages[$this->_get]}
              </div>";
            unset($message[$this->_get], $this->types[$this->_get]);
        }
    }

    public function get($key = NULL)
    {
        $this->_get = $key;
        return $this;
    }

    public function showAll()
    {
        $allMessages = "";
        $i = 0;
        foreach ($this->_messages as $message) {
            $allMessages .= "<div class='alert alert-{$this->types[$i]} alert-dismissible' role='alert'>
                            <button type='button' class='close' data-dismiss='alert' aria-label='Close'><span aria-hidden='true'>&times;</span></button>
                            {$message}
                          </div>";
            $i++;
        }
        $this->messages = array();
        $this->types = array();
    }
    
    public function errorExists(){
        return in_array("danger", $this->types) || in_array("danger", unserialize($_SESSION["types"]))  ? TRUE : FALSE;
    }

    public function removeAllMessages(){
        $this->messages = array();
        $this->types = array();
        unset($_SESSION['messages'], $_SESSION['types']);
    }

    public function remove(){
        if($this->_get != null){
            unset($this->messages[$this->_get]);
            unset($this->types[$this->_get]);
            $_SESSION['messages'] = serialize($this->_messages);
            $_SESSION['types'] = serialize($this->_types);
        }
    }
}


?>
