<?php
/**
 * Created by PhpStorm.
 * User: Jan
 * Date: 23. 12. 2015
 * Time: 22:18
 */

namespace Light\ORM;


class ORMEngine
{

    private static $_instance = null;

    public static function getInstance()
    {
        if (self::$_instance === null) {
            self::$_instance = new self;
        }
        return self::$_instance;
    }

    public function recordToClass(&$prevRecord,$record, $returningClass, &$ormresult){
        $recordTables = array_keys($record);
        $table = self::toDatabaseRelatedName($returningClass);

        $is_prev = false;
        if($prevRecord==NULL){
                $returningClass = new $returningClass();
        }else{
            if(($prevRecord->getId() != $record[$table]["id"])){
                $returningClass = new $returningClass();
            }else{
                $returningClass = $prevRecord;
                $is_prev = true;
            }
        }
        foreach($recordTables as &$tablename){
            if($table!=$tablename){
                $ClassName = self::toObjectRelatedName($tablename);
                $newInstance = new $ClassName();
            }else{
                $newInstance = $returningClass;
            }
            //FILLING OBJECT
            if($table!=$tablename or !$is_prev) {
                $newInstance->loadArray($record[$tablename]);
            }
            if($table!=$tablename) {
                $fn1 = "set" . $ClassName;
                $fn2 = "add" . $ClassName;
                if (method_exists($returningClass, $fn1)) {
                    $returningClass->$fn1($newInstance);
                } elseif (method_exists($returningClass, $fn2)) {
                    $returningClass->$fn2($newInstance);
                }
            }
        }

        if(!$is_prev){
            $ormresult[] = $returningClass;
        }
    }

    public function toUpdateString($obj){
        $table = $this->toDatabaseRelatedName(get_class($obj));
        $SQLArray = array();

        if($obj->getId()){
            $query = "UPDATE ".$table." SET ";
            $formulaArray = array();
            $valuesArray = array();

            foreach($obj->queue as $prop => &$val){

                $formulaArray[] = $prop."=:".$prop;
                $valuesArray[":".$prop] = $val;
            }

            $query .= implode(", ",$formulaArray)." where ".$table."_id=".$obj->getId();
            $SQLArray[] = $query;
            $SQLArray[] = $valuesArray;
            $SQLArray[] = 0;
        }else{
            $query = "INSERT INTO ".$table;
            $valuesArray = array();
            $columns = array();

            foreach($obj->getProperities() as $k=>$v){
                   if(explode("_",$k)[0] == $table){
                       $valuesArray[":".$k] = $v;
                       $columns[] = $k;
                   }
            }

            $query .= "(".implode(", ",$columns).") values(".implode(", ",array_keys($valuesArray)).")";
            //echo $query;
            $SQLArray[] = $query;
            $SQLArray[] = $valuesArray;
            $SQLArray[] = 1;
        }
        return $SQLArray;
    }

    private function toObjectRelatedName($dbname){
        $arr = explode("_",$dbname);
        $property = $arr[0];
        $count = count($arr);
        if($count>1){
            for($i=1;$i<$count;$i++){
                $property .= ucfirst($arr[$i]);
            }
        }else{
            $property = ucfirst($property);
        }
        return $property;
    }

    private function toDatabaseRelatedName($obj){
        $words = preg_split('/(?=[A-Z])/', $obj, -1, PREG_SPLIT_NO_EMPTY);
        foreach($words as &$word){
            $word = strtolower($word);
        }
        return implode("_", $words);;
    }

}