<?php
/**
 * Created by PhpStorm.
 * User: Shadow
 * Date: 19.12.2015
 * Time: 22:33
 */

namespace Light\ORM;
use PDO;

class Query
{
    private $query = null;
    private $where = array();
    private $set = array();
    private $first = false;
    private $params = array();
    private $from = array();
    private $columns = array();

    public function select($columns){
        $this->query = "SELECT ".implode(", ", $columns);
        $this->columns = $columns;
        return $this;
    }

    public function update($tbl){
        $this->query = "UPDATE ".$tbl;
        return $this;
    }

    public function insert($tbl){
        $this->query = "INSERT INTO ".$tbl;
        return $this;
    }

    public function  delete($tbl){
        $this->query = "DELETE FROM ".$tbl;
        return $this;
    }

    public function replace($tbl){
        $this->query = "REPLACE INTO ".$tbl;
        return $this;
    }

    public  function from($tables,$join=false){
        $this->query .= " FROM ".$tables[0];
        if($join){
            $count = count($tables);
            for($i=1; $i<$count;$i++){
                if($i){
                    $this->query .= " JOIN ".$tables[$i]. "on" . $tables[$i-1].".".$tables[$i-1]."_id=".$tables[$i].".".$tables[$i-1]."_id";
                }
            }
        }
        $this->from = $tables;
        return $this;
    }

    public  function join($tbl,$fk_key){
        $this->query .= " JOIN ".$tbl." ON ".$fk_key;
        return $this;
    }
    public function values($array){
        $keys = array_keys($array);
        $values = array();

        foreach($array as $item){
            if(strpos($item, ":")){
                $values[] = $item;
            }else{
                $values[] = "'$item'";
            }
        }

        if(gettype($keys[0]) == "string"){
            $this->query .= "(".implode(", ",$keys).") VALUES (".implode(", ".$values).")";
        }else{
            $this->query .= " VALUES (".implode(", ".$values).")";
        }
        return $this;
    }

    public function set($array){
        $setArray = array();
        foreach($array as $key=>$item){
            if(strpos($item, ":")){
                $setArray[] = "$key=$item";
            }else{
                $setArray[] = "$key='$item'";
            }
        }
        $this->query .= " ".implode(", ",$setArray);
        return $this;
    }

    public function addSet($st){
        $this->set[] = $st;
        return $this;
    }

    public function setParameters($array){
        $this->params = $array;
        return $this;
    }

    public function  setParameter($p,$v){
        $this->params[$p] = $v;
        return $this;
    }

    public function addWhere($wh){
        $this->where[] = $wh;
        return $this;
    }

    public function where($wh){
        $this->query .= " WHERE ".$wh;
        return $this;
    }

    public function limit($lim){
        $this->query .= " LIMIT ".$lim;
        return $this;
    }

    public  function  orderBy($ord){
        $this->query .= " ORDER BY ".$ord;
        return $this;
    }

    public  function groupBy($grby){
        $this->query .= " GROUP BY ".implode(", ",$grby);
        return $this;
    }

    public function first(){
        $this->first = true;
        return $this;
    }

    public function execute($returningClass){

        DatabaseWorker::getInstance()->ConnectDatabase();
        $conn = DatabaseWorker::getInstance()->getConnection();
        $dbh = $conn->prepare($this->query);

        if(count($this->params)){
            foreach($this->params as $k => &$v) {
                $type = gettype($v);
                switch ($type) {
                    case "integer":
                        $dbh->bindParam(":$k", $v, PDO::PARAM_INT);
                        break;
                    case "string":
                        $dbh->bindParam(":$k", $v, PDO::PARAM_STR);
                        break;
                    case "boolean":
                        $dbh->bindParam(":$k", $v, PDO::PARAM_BOOL);
                        break;
                    default:
                        $dbh->bindParam(":$k", $v, PDO::PARAM_STR);
                        break;
                }
            }
        }

        $dbh->execute();
        $result = $dbh->fetchAll(PDO::FETCH_ASSOC);
        $rc = count($result);

        if(!$rc){return null;}

        $ormresult = array();
        $notprev = null;

        $splittedRec = $this->splitRecordToArray($dbh,$result[0]);
        ORMEngine::getInstance()->recordToClass($notprev ,$splittedRec,$returningClass,$ormresult);

        for($i=1;$i<$rc;$i++){
            $splittedRec = $this->splitRecordToArray($dbh,$result[$i]);
            ORMEngine::getInstance()->recordToClass($ormresult[$i-1],$splittedRec,$returningClass,$ormresult);
        }

        $this->query = null;
        return $ormresult;
    }
    public function NativeQuery($stm,$params){
        $conn = DatabaseWorker::getInstance()->getConnection();
        $dbh = $conn->prepare($stm);
        if(isset($params)){
            foreach($params as $k => $v) {
                $type = gettype($v);
                switch ($type) {
                    case "integer":
                        $dbh->bindParam(":$k", $v, PDO::PARAM_INT);
                        break;
                    case "string":
                        $dbh->bindParam(":$k", $v, PDO::PARAM_STR);
                        break;
                    case "boolean":
                        $dbh->bindParam(":$k", $v, PDO::PARAM_BOOL);
                        break;
                    default:
                        $dbh->bindParam(":$k", $v, PDO::PARAM_STR);
                        break;
                }
            }
        }
        $dbh->execute();
        if($this->first){
            return $dbh->fetchAll()[0];
            $this->$first = false;
        }else{
            return $dbh->fetchAll();
        }
    }

    private function splitRecordToArray(&$dbh,$record){
        $splittedRecord = [];
        $i=0;

        foreach($record as $attribute=>&$attributeValue){
            $meta = $dbh->getColumnMeta($i);
            $table = $meta["table"];
            $splittedRecord[$table][$attribute] = $attributeValue;
            $i++;
        }
        return $splittedRecord;
    }

}