<?php
/**
 * Created by PhpStorm.
 * User: Shadow
 * Date: 07.06.2016
 * Time: 21:07
 */

namespace Light\ORM;
use PDO;


class Reflection
{
    private $errors = array();

    public function synchronize(&$objects){

        DatabaseWorker::getInstance()->ConnectDatabase();
        $conn = DatabaseWorker::getInstance()->getConnection();

        foreach($objects as &$object){
            $array = ORMEngine::getInstance()->toUpdateString($object);
            $dbh = $conn->prepare($array[0]); //ARRAY[0] - QUERY WITH PARAMETERS

            $conn->beginTransaction();
            try{
                $dbh->execute($array[1]); // ARRAY[1] - VALUES TO PASS BY PARAMETERS IN QUERY
                $conn->commit();
                if($array[2]){    // ARRAY[2] - QUERY TYPE(INSERT/UPDATE) RETURNS 0 IN CASE OF UPDATE AND IN CASE OF INSERT
                    $lastid = $conn->lastInsertId();
                    $object->setId($lastid);
                }
            }catch (\PDOException $e){
                $this->errors[] = $e->getMessage();
                echo $e->getMessage();
                $conn->rollback();
            }
        }
    }

    public function hasErrors(){
        return count($this->errors);
    }

    public function getErrors(){
        return $this->errors;
    }
}