<?php
/**
 * Created by PhpStorm.
 * User: Shadow
 * Date: 21.06.2016
 * Time: 11:24
 */

namespace Light\ORM\Repository;


class UserRepository implements IUserRepository
{
    private $users;

    public function findUserById($id)
    {
        return $this->users[$id];
    }

    public function findUserByUsername($username)
    {
        return array_filter($this->users, function ($user) use ($username) {
            return $this->user->username === $username;
        });
    }

    public function add(User $user)
    {
        $this->users[$user->id] = $user;
    }

    public function remove($id)
    {
        unset($this->users[$id]);
    }
}