var Ajax = (function () {
    function Ajax() {
        this.url = null;
        this.data = null;
        this.type = "GET";
        this.dataType = "HTML";
        this.imageURL = "Images/ajax-loader.gif";
        this.loadingElement = null;
        this.loaderElement = null;
        this.xhr = null;
        this.result = null;
        this.async = true;
        this.body = null;
        this.errFlag = true;
        this.doneFlag = null;
        this.doneFunction = null;
        if (arguments.length && typeof (arguments[0]) == "object" && typeof (arguments[0]) != "undefined") {
            var obj = arguments[0];
            for (var prop in Object.keys(obj)) {
                var _property = Object.keys(obj)[prop] + "";
                if (this.hasOwnProperty(_property)) {
                    eval("this." + _property + " = arguments[0]." + _property);
                }
            }
        }
        if (window.ActiveXObject || "ActiveXObject" in window) {
            try {
                this.xhr = new ActiveXObject("Microsoft.XMLHTTP");
            }
            catch (e) {
                console.log(e.message);
                this.xhr = null;
            }
        }
        else {
            this.xhr = new XMLHttpRequest();
        }
    }
    Ajax.prototype.Settings = function (a) {
        if (arguments.length) {
            var obj = arguments[0];
            for (var prop in Object.keys(obj)) {
                var _property = Object.keys(obj)[prop] + "";
                if (this.hasOwnProperty(_property)) {
                    eval("this." + _property + " = arguments[0]." + _property);
                }
            }
        }
        return this;
    };
    Ajax.prototype.Start = function () {
        var xhr = this.xhr;
        var self = this;
        document.getElementById(self.loaderElement).appendChild(self.initLoadingElement());
        this.doneFlag = false;
        xhr.onreadystatechange = function () {
            if (self.xhr.readyState === 4) {
                self.result = self.xhr.responseText;
                document.getElementById(self.loaderElement).removeChild(self.loadingElement);
                if (self.dataType == "json") {
                    self.result = JSON.parse(self.result);
                }
                (self.doneFunction)(self.result);
            }
            else {
                self.errFlag = true;
            }
        };
        if (this.type.toUpperCase() == "GET") {
            this.xhr.open(this.type, this.url, this.async);
        }
        else {
            this.xhr.open(this.type, this.url, this.async);
        }
        this.xhr.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
        this.xhr.setRequestHeader('X-Requested-With', 'XMLHttpRequest');
        this.xhr.send(this.body);
        return self;
    };
    Ajax.prototype.Serialize = function (source) {
        switch (source.tagName.toLowerCase()) {
            case "form": this.SerializeForm(source);
            case "input": this.SerializeInput(source.name, source.value);
        }
        return this;
    };
    Ajax.prototype.SerializeForm = function (s) {
        var _finalArray = new Array();
        var _formArray = s.elements;
        for (var e in _formArray) {
            var _e = _formArray[e];
            switch (_e) {
                case "input":
                    _finalArray.push(this.SerializeInput(_e.name, _e.value));
                    break;
                case "select":
                    _finalArray.push(this.SerializeInput(_e.options[_e.selectedIndex].name, _e.options[_e.selectedIndex].value));
                    break;
                case "checkbox":
                    if (_e.checked)
                        _finalArray.push(this.SerializeInput(_e.name, _e.value));
                    break;
            }
        }
        this.type = s.method;
        if (this.type.toUpperCase() == "GET") {
            this.url = s.action + _finalArray.join("&");
        }
        else {
            this.body = _finalArray.join("&");
            this.url = s.action;
        }
    };
    Ajax.prototype.SerializeInput = function (name, value) {
        return name + "=" + encodeURI(value);
    };
    Ajax.prototype.SerializeJSON = function (name, obj) {
        return name + "=" + encodeURIComponent(JSON.stringify(obj));
    };
    Ajax.prototype.PushSerializedData = function (data) {
        if (this.url.indexOf(".php") + 4 == this.url.length) {
            this.url += "?" + data;
        }
        else {
            this.url += "&" + data;
        }
        return this;
    };
    Ajax.prototype.PushData = function (name, value) {
        var serialized = null;
        switch (typeof (value)) {
            case "Object":
                serialized = this.SerializeJSON(name, value);
                break;
            case "String":
                serialized = this.SerializeInput(name, value);
                break;
            default:
                serialized = this.SerializeInput(name, value);
                break;
        }
        if (this.url.indexOf(".php") + 4 == this.url.length) {
            this.url += "?" + serialized;
            return this;
        }
        this.url += "&" + serialized;
        return this;
    };
    Ajax.prototype.initLoadingElement = function () {
        var x = document.createElement("DIV");
        x.className = "AJAX_LOADER_IMAGE";
        x.style.backgroundImage = "url('" + this.imageURL + "')";
        this.loadingElement = x;
        return x;
    };
    //ON ACTION
    Ajax.prototype.onStart = function (a) {
        (a)();
    };
    Ajax.prototype.onError = function (a) {
        if (this.errFlag)
            (a)();
        return this;
    };
    Ajax.prototype.done = function (a) {
        this.doneFunction = a;
        return this;
    };
    return Ajax;
})();
//# sourceMappingURL=ajax.js.map