/*
// Interface
interface IPoint {
    getDist(): number;
}

// Module
module Shapes {

    // Class
    export class Point implements IPoint {
        // Constructor
        constructor (public x: number, public y: number) { }

        // Instance member
        getDist() { return Math.sqrt(this.x * this.x + this.y * this.y); }

        // Static member
        static origin = new Point(0, 0);
    }

}

// Local variables
var p: IPoint = new Shapes.Point(3, 4);
var dist = p.getDist();
*/
var Graphics = (function () {
    function Graphics() {
        this.processArray = new Array();
    }
    Graphics.prototype.LaunchIntoFullscreen = function (element) {
        /// <summary>Display element to fullscreen.</summary>
        /// <param name="element" type="any">Element which should be displayed to full screen.</param>
        if (element.requestFullscreen) {
            element.requestFullscreen();
        }
        else if (element.mozRequestFullScreen) {
            element.mozRequestFullScreen();
        }
        else if (element.webkitRequestFullscreen) {
            element.webkitRequestFullscreen();
        }
        else if (element.msRequestFullscreen) {
            element.msRequestFullscreen();
        }
    };
    Graphics.prototype.ExitFullscreen = function () {
        if (document.exitFullscreen) {
            document.exitFullscreen();
        }
        else if (document.mozCancelFullScreen) {
            document.mozCancelFullScreen();
        }
        else if (document.webkitExitFullscreen) {
            document.webkitExitFullscreen();
        }
    };
    Graphics.prototype.FlashExpand = function (el) {
        if (this.FlashExpand.arguments.lenght == 2) {
            el.style.width = this.FlashExpand.arguments[1] + "px";
        }
        if (this.FlashExpand.arguments.lenght == 3) {
            el.style.width = this.FlashExpand.arguments[1] + "px";
            el.style.height = this.FlashExpand.arguments[2] + "px";
        }
    };
    Graphics.prototype.Expand = function (exp) {
        var _this = this;
        var pr1 = null;
        var pr2 = null;
        0;
        this.timerToken = setInterval(function () {
            if (exp.y != null) {
                var h = exp.element.clientHeight;
                if (h < exp.y) {
                    exp.element.style.height = h + exp.step + "px";
                }
                else {
                    pr1 = true;
                    if (pr2 || exp.x == null) {
                        clearTimeout(_this.timerToken);
                    }
                }
            }
            if (exp.x != null) {
                var w = exp.element.clientWidth;
                if (w < exp.x) {
                    exp.element.style.width = w + exp.step + "px";
                }
                else {
                    pr2 = true;
                    if (pr1 || exp.y == null) {
                        clearTimeout(_this.timerToken);
                    }
                }
            }
        }, exp.timing);
    };
    Graphics.prototype.Collapse = function (col) {
        var _this = this;
        var pr1 = null;
        var pr2 = null;
        this.timerToken = setInterval(function () {
            if (col.y != null) {
                var h = col.element.clientHeight;
                if (h > col.y) {
                    col.element.style.height = h - col.step + "px";
                }
                else {
                    pr1 = true;
                    if (pr2 || col.x == null) {
                        clearTimeout(_this.timerToken);
                    }
                }
            }
            if (col.x != null) {
                var w = col.element.clientWidth;
                if (w > col.x) {
                    col.element.style.width = w - col.step + "px";
                }
                else {
                    pr2 = true;
                    if (pr1 || col.y == null) {
                        clearTimeout(_this.timerToken);
                    }
                }
            }
        }, col.timing);
    };
    Graphics.prototype.ToogleDisplay = function (xl) {
        var display = xl.style.display;
        if (display == "block") {
            xl.style.display = "none";
        }
        else {
            xl.style.display = "block";
        }
    };
    Graphics.prototype.moveTo = function (p) {
        var _startY = parseInt(p.element.style.top);
        var _startX = parseInt(p.element.style.left);
        var coefX = p.y - _startY;
        var coefY = -(p.x - _startX);
        var coef = -(coefX * _startX) - (coefY * _startY);
        var fceY = function (x) {
            var y = (-(coefX * x) - coef) / coefY;
            return y;
        };
        this.timerToken = setInterval(function () {
            if (_startX < p.x) {
                var _x = parseInt(p.element.style.left) + p.step;
                var _y = fceY(_x);
                p.element.style.left = _x + "px";
                p.element.style.top = _y + "px";
            }
            else {
                var _x = parseInt(p.element.style.left) - p.step;
                var _y = fceY(_x);
                p.element.style.left = _x + "px";
                p.element.style.top = _y + "px";
            }
        }, p.timing);
    };
    Graphics.prototype.moveToByCSS = function (p) {
        p.element.style.transition = "transform " + p.timing + "s";
        p.element.style.transform = "translate(" + p.x + "px, " + p.y + "px)";
    };
    Graphics.prototype.isCollide = function (p1, p2) {
        if (Math.abs(p1.x - p2.x) < p1.a && Math.abs(p1.y - p2.y) < p1.b) {
            var colision_area = this.getOverlapingRegion(p1, p2);
            var obsah_p1 = p1.a * p1.b;
            if (colision_area.obsah / obsah_p1 > 0.8) {
                return colision_area.region;
            }
        }
        return "CC";
    };
    Graphics.prototype.getOverlapingRegion = function (t1, t2) {
        if (t1.x > t2.x && t1.y > t2.y) {
            var _a = t2.x + t2.a - t1.x;
            var _b = t2.y + t2.b - t1.y;
            if (_a > _b)
                return { region: "S", obsah: _a * _b };
            else
                return { region: "E", obsah: _a * _b };
        }
        if (t1.x < t2.x && t1.y < t2.y) {
            var _a = t1.x + t1.a - t2.x;
            var _b = t1.y + t1.b - t2.y;
            if (_a > _b)
                return { region: "N", obsah: _a * _b };
            else
                return { region: "W", obsah: _a * _b };
        }
        if (t1.x < t2.x && t1.y > t2.y) {
            var _a = t1.x + t1.a - t2.x;
            var _b = t2.y + t2.b - t1.y;
            if (_a > _b)
                return { region: "S", obsah: _a * _b };
            else
                return { region: "w", obsah: _a * _b };
        }
        if (t1.x > t2.x && t1.y < t2.y) {
            var _a = t2.x + t2.a - t1.x;
            var _b = t1.y + t1.b - t2.y;
            if (_a > _b)
                return { region: "N", obsah: _a * _b };
            else
                return { region: "E", obsah: _a * _b };
        }
    };
    Graphics.prototype.detectCollision = function (w) {
        for (var i = 0; i < widgetArray.length; i++) {
            var pc = widgetArray[i]; //potencional collision elements
            if (this.isCollide(w, pc) != "CC") {
            }
            else {
                return 0;
            }
        }
    };
    return Graphics;
})();
var Params = (function () {
    function Params(element, x, y, step, timing) {
        this.element = element;
        this.x = x;
        this.y = y;
        this.step = step;
        this.timing = timing;
    }
    return Params;
})();
var Tile = (function () {
    function Tile(el) {
        this.x = parseInt(el.style.left);
        this.y = parseInt(el.style.top);
        this.a = parseInt(el.style.width);
        this.b = parseInt(el.style.height);
    }
    return Tile;
})();
//# sourceMappingURL=class.Graphics.js.map