/*
// Interface
interface IPoint {
    getDist(): number;
}

// Module
module Shapes {

    // Class
    export class Point implements IPoint {
        // Constructor
        constructor (public x: number, public y: number) { }

        // Instance member
        getDist() { return Math.sqrt(this.x * this.x + this.y * this.y); }

        // Static member
        static origin = new Point(0, 0);
    }

}

// Local variables
var p: IPoint = new Shapes.Point(3, 4);
var dist = p.getDist();
*/
class Graphics
{
    private timerToken: number;
    private processArray = new Array();

    public LaunchIntoFullscreen(element) {
    /// <summary>Display element to fullscreen.</summary>
    /// <param name="element" type="any">Element which should be displayed to full screen.</param>
        if (element.requestFullscreen) {
            element.requestFullscreen();
        } else if (element.mozRequestFullScreen) {
            element.mozRequestFullScreen();
        } else if (element.webkitRequestFullscreen) {
            element.webkitRequestFullscreen();
        } else if (element.msRequestFullscreen) {
            element.msRequestFullscreen();
        }
    }
    public ExitFullscreen() {
    if (document.exitFullscreen) {
        document.exitFullscreen();
    } else if (document.mozCancelFullScreen) {
        document.mozCancelFullScreen();
    } else if (document.webkitExitFullscreen) {
        document.webkitExitFullscreen();
    }
    }
    public FlashExpand(el:HTMLElement) {
        if (this.FlashExpand.arguments.lenght == 2) {
            el.style.width = this.FlashExpand.arguments[1] + "px";
        }
        if (this.FlashExpand.arguments.lenght == 3) {
            el.style.width = this.FlashExpand.arguments[1] + "px";
            el.style.height = this.FlashExpand.arguments[2] + "px";
        }
    }
    public Expand(exp: Params) {
        var pr1 = null;
        var pr2 = null;0

        this.timerToken = setInterval(() => {
            if (exp.y != null) {               
                var h = exp.element.clientHeight;                           
                if (h < exp.y) {                    
                    exp.element.style.height = h + exp.step + "px";
                } else {
                pr1 = true;
                if (pr2 || exp.x == null){clearTimeout(this.timerToken);}
                }              
            }
            if (exp.x != null) {               
                var w = exp.element.clientWidth;              
                if (w < exp.x) {
                    exp.element.style.width = w + exp.step + "px";
                } else {
                pr2 = true;
                if (pr1 || exp.y == null) { clearTimeout(this.timerToken);}
                }               
            }         
        }, exp.timing);
    } 
    public Collapse(col: Params) {
        var pr1 = null;
        var pr2 = null;

        this.timerToken = setInterval(() => {
            if (col.y != null) {
                var h = col.element.clientHeight;
                if (h > col.y) {
                    col.element.style.height = h - col.step + "px";
                } else {
                    pr1 = true;
                    if (pr2 || col.x == null) { clearTimeout(this.timerToken); }
                }
            }
            if (col.x != null) {
                var w = col.element.clientWidth;
                if (w > col.x) {
                    col.element.style.width = w - col.step + "px";
                } else {
                    pr2 = true;
                    if (pr1 || col.y == null) { clearTimeout(this.timerToken); }
                }
            }
        }, col.timing);
    }
    public ToogleDisplay(xl:HTMLElement) {
        var display = xl.style.display;
        if (display == "block") { xl.style.display = "none"; } else { xl.style.display = "block";}
    }
    public moveTo(p:Params) {
        var _startY = parseInt(p.element.style.top);
        var _startX = parseInt(p.element.style.left);

        var coefX = p.y - _startY;
        var coefY = -(p.x - _startX);
        var coef = -(coefX * _startX) - (coefY * _startY);
        var fceY = function (x: number) { var y = (-(coefX * x) - coef) / coefY; return y };
        this.timerToken = setInterval(() => { //Chyb kritria pro stop
            if (_startX < p.x) {
                var _x = parseInt(p.element.style.left) + p.step;
                var _y = fceY(_x);
                p.element.style.left = _x + "px";
                p.element.style.top = _y + "px";
            } else {
                var _x = parseInt(p.element.style.left) - p.step;
                var _y = fceY(_x);
                p.element.style.left = _x + "px";
                p.element.style.top = _y + "px";
            }
        }, p.timing);  
    }
    public moveToByCSS(p:Params) {
        p.element.style.transition = "transform " + p.timing + "s";
        p.element.style.transform = "translate(" + p.x + "px, " + p.y + "px)";        
    }
    public isCollide(p1:Tile, p2:Tile) {        
        if (Math.abs(p1.x - p2.x) < p1.a && Math.abs(p1.y - p2.y) < p1.b) {
            var colision_area = this.getOverlapingRegion(p1, p2);
            var obsah_p1 = p1.a * p1.b;
            if (colision_area.obsah/obsah_p1 > 0.8) {
                return colision_area.region;
            }
        }      
        return "CC";
    }
    public getOverlapingRegion(t1:Tile, t2:Tile) {
        if (t1.x > t2.x && t1.y > t2.y) {
            var _a = t2.x + t2.a - t1.x;
            var _b = t2.y + t2.b - t1.y;
            if (_a > _b) return { region: "S", obsah: _a * _b };
            else return { region: "E", obsah: _a * _b };
        } 
        if (t1.x < t2.x && t1.y < t2.y) {
            var _a = t1.x + t1.a - t2.x;
            var _b = t1.y + t1.b - t2.y;
            if (_a > _b) return { region: "N", obsah: _a * _b };
            else return { region: "W", obsah: _a * _b };
        }
        if (t1.x < t2.x && t1.y > t2.y) {
            var _a = t1.x + t1.a - t2.x;
            var _b = t2.y + t2.b - t1.y;
            if (_a > _b) return { region: "S", obsah: _a * _b };
            else return { region: "w", obsah: _a * _b };
        }
        if (t1.x > t2.x && t1.y < t2.y) {
            var _a = t2.x + t2.a - t1.x;
            var _b = t1.y + t1.b - t2.y;
            if (_a > _b) return { region: "N", obsah: _a * _b };
            else return { region: "E", obsah: _a * _b };
        }
    }
    public detectCollision(w) {
        for (var i = 0; i < widgetArray.length; i++) {
            var pc = widgetArray[i]; //potencional collision elements
            if (this.isCollide(w, pc) != "CC") {

            } else { return 0;}
        }
    }
    public

}
class Params {
    public element: HTMLElement;
    public x: number;
    public y: number;
    public timing: number;
    public step: number;
    constructor(element:HTMLElement,x: number, y: number, step:number,timing:number)
    {
        this.element = element;
        this.x = x;
        this.y = y;
        this.step = step;
        this.timing = timing;
    }

}
class Tile {
    public x: number;
    public y: number;
    public a: number;
    public b: number;
    constructor(el) {
        this.x = parseInt(el.style.left);
        this.y = parseInt(el.style.top);
        this.a = parseInt(el.style.width);
        this.b = parseInt(el.style.height);      
    }
}